Index: trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/PermissionOwnerAdapter.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/PermissionOwnerAdapter.cs	(revision 994)
+++ trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/PermissionOwnerAdapter.cs	(revision 995)
@@ -30,23 +30,20 @@
 
 namespace HeuristicLab.Hive.Server.ADODataAccess {
-  class PermissionOwnerAdapter: DataAdapterBase, IPermissionOwnerAdapter {
-    private dsHiveServerTableAdapters.PermissionOwnerTableAdapter adapter =
-     new dsHiveServerTableAdapters.PermissionOwnerTableAdapter();
+  class PermissionOwnerAdapter: 
+    DataAdapterBase<
+      dsHiveServerTableAdapters.PermissionOwnerTableAdapter, 
+      PermissionOwner, 
+      dsHiveServer.PermissionOwnerRow>, 
+    IPermissionOwnerAdapter {
+    #region Fields
+    dsHiveServer.PermissionOwnerDataTable data =
+        new dsHiveServer.PermissionOwnerDataTable();
+    #endregion
 
-    private dsHiveServer.PermissionOwnerDataTable data =
-      new dsHiveServer.PermissionOwnerDataTable();
-
-    public PermissionOwnerAdapter() {
-      adapter.Fill(data);
-    }
-
-    protected override void Update() {
-      this.adapter.Update(this.data);
-    }
-
-    private PermissionOwner Convert(dsHiveServer.PermissionOwnerRow row,
+    #region Overrides
+    protected override PermissionOwner Convert(dsHiveServer.PermissionOwnerRow row,
       PermissionOwner permOwner) {
       if (row != null && permOwner != null) {
-        permOwner.PermissionOwnerId = row.PermissionOwnerId;
+        permOwner.Id = row.PermissionOwnerId;
 
         if (!row.IsNameNull())
@@ -60,5 +57,5 @@
     }
 
-    private dsHiveServer.PermissionOwnerRow Convert(PermissionOwner permOwner,
+    protected override dsHiveServer.PermissionOwnerRow Convert(PermissionOwner permOwner,
       dsHiveServer.PermissionOwnerRow row) {
       if (row != null && permOwner != null) {
@@ -69,29 +66,37 @@
         return null;
     }
-    
+
+    protected override dsHiveServer.PermissionOwnerRow
+      InsertNewRow(PermissionOwner permOwner) {
+      dsHiveServer.PermissionOwnerRow row =
+        data.NewPermissionOwnerRow();
+
+      data.AddPermissionOwnerRow(row);
+
+      return row;
+    }
+
+    protected override void
+      UpdateRow(dsHiveServer.PermissionOwnerRow row) {
+      adapter.Update(row);
+    }
+
+    protected override IEnumerable<dsHiveServer.PermissionOwnerRow>
+      FindById(long id) {
+      return adapter.GetDataById(id);
+    }
+
+    protected override IEnumerable<dsHiveServer.PermissionOwnerRow>
+      FindAll() {
+      return adapter.GetData();
+    }
+    #endregion
+
     #region IPermissionOwner Members
-    [MethodImpl(MethodImplOptions.Synchronized)]
-    public void UpdatePermissionOwner(PermissionOwner permOwner) {
+
+    public bool GetById(PermissionOwner permOwner) {
       if (permOwner != null) {
         dsHiveServer.PermissionOwnerRow row = 
-          data.FindByPermissionOwnerId(permOwner.PermissionOwnerId);
-        
-        if (row == null) {
-          row = data.NewPermissionOwnerRow();
-          data.AddPermissionOwnerRow(row);
-
-          //write row to db to get primary key
-          adapter.Update(row);
-        }
-
-        Convert(permOwner, row);
-        permOwner.PermissionOwnerId = row.PermissionOwnerId;
-      }
-    }
-
-    public bool GetPermissionOwnerById(PermissionOwner permOwner) {
-      if (permOwner != null) {
-          dsHiveServer.PermissionOwnerRow row =
-            data.FindByPermissionOwnerId(permOwner.PermissionOwnerId);
+          base.GetRowById(permOwner.Id);
 
         if(row != null) {
@@ -104,65 +109,14 @@
       return false;
     }
-
-    public PermissionOwner GetPermissionOwnerById(long permOwnerId) {
-      PermissionOwner permOwner = new PermissionOwner();
-      permOwner.PermissionOwnerId = permOwnerId;
-
-      if (GetPermissionOwnerById(permOwner))
-        return permOwner;
-      else
-        return null;
-    }
-
-    public PermissionOwner GetPermissionOwnerByName(String name) {
-       dsHiveServer.PermissionOwnerRow row = null;
-
-      IEnumerable<dsHiveServer.PermissionOwnerRow> permOwners =
-        from r in
-          data.AsEnumerable<dsHiveServer.PermissionOwnerRow>()
-        where !r.IsNameNull() && r.Name == name
-        select r;
-
-      if (permOwners.Count<dsHiveServer.PermissionOwnerRow>() == 1)
-        row = permOwners.First<dsHiveServer.PermissionOwnerRow>();
-
-      if (row != null) {
-        PermissionOwner permOwner = new PermissionOwner();
-        Convert(row, permOwner);
-
-        return permOwner;
-      } else {
-        return null;
-      }
-    }
-
-    public ICollection<PermissionOwner> GetAllPermissionOwners() {
-      ICollection<PermissionOwner> allPermissionOwners =
-        new List<PermissionOwner>();
-
-      foreach (dsHiveServer.PermissionOwnerRow row in data) {
-        PermissionOwner permOwner = new PermissionOwner();
-        Convert(row, permOwner);
-        allPermissionOwners.Add(permOwner);
+    
+    public PermissionOwner GetByName(String name) {
+      if (name != null) {
+        return base.FindSingle(
+          delegate() {
+            return adapter.GetDataByName(name);
+          });
       }
 
-      return allPermissionOwners;
-    }
-
-    [MethodImpl(MethodImplOptions.Synchronized)]
-    public bool DeletePermissionOwner(PermissionOwner permOwner) {
-      if (permOwner != null) {
-          dsHiveServer.PermissionOwnerRow row = 
-            data.FindByPermissionOwnerId(permOwner.PermissionOwnerId);
-
-          if(row != null) {
-            row.Delete();
-            adapter.Update(row);
-          
-            return true;
-          }
-        }
-
-      return false;
+      return null;
     }
 
Index: trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/ResourceAdapter.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/ResourceAdapter.cs	(revision 994)
+++ trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/ResourceAdapter.cs	(revision 995)
@@ -29,23 +29,32 @@
 
 namespace HeuristicLab.Hive.Server.ADODataAccess {
-  class ResourceAdapter: DataAdapterBase, IResourceAdapter {
-    private dsHiveServerTableAdapters.ResourceTableAdapter adapter =
-        new dsHiveServerTableAdapters.ResourceTableAdapter();
-
-    private dsHiveServer.ResourceDataTable data =
+  class ResourceAdapter: 
+    CachedDataAdapter<
+      dsHiveServerTableAdapters.ResourceTableAdapter, 
+      Resource, 
+      dsHiveServer.ResourceRow, 
+      dsHiveServer.ResourceDataTable>,  
+    IResourceAdapter {
+    #region Fields
+    dsHiveServer.ResourceDataTable data =
         new dsHiveServer.ResourceDataTable();
 
-    public ResourceAdapter() {
-      adapter.Fill(data);
+    private IClientAdapter clientAdapter = null;
+
+    private IClientAdapter ClientAdapter {
+      get {
+        if (clientAdapter == null)
+          clientAdapter = ServiceLocator.GetClientAdapter();
+        
+        return clientAdapter;
+      }
     }
+    #endregion
 
-    protected override void Update() {
-      this.adapter.Update(this.data);
-    }
-
-    private Resource Convert(dsHiveServer.ResourceRow row,
+    #region Overrides
+    protected override Resource Convert(dsHiveServer.ResourceRow row,
       Resource resource) {
       if (row != null && resource != null) {
-        resource.ResourceId = row.ResourceId;
+        resource.Id = row.ResourceId;
         if (!row.IsNameNull())
           resource.Name = row.Name;
@@ -58,5 +67,5 @@
     }
 
-    private dsHiveServer.ResourceRow Convert(Resource resource,
+    protected override dsHiveServer.ResourceRow Convert(Resource resource,
       dsHiveServer.ResourceRow row) {
       if (resource != null && row != null) {
@@ -68,28 +77,61 @@
     }
 
+    protected override void UpdateRow(dsHiveServer.ResourceRow row) {
+      adapter.Update(row);
+    }
+
+    protected override dsHiveServer.ResourceRow
+      InsertNewRow(Resource resource) {
+      dsHiveServer.ResourceRow row = data.NewResourceRow();
+      data.AddResourceRow(row);
+
+      return row;
+    }
+
+    protected override dsHiveServer.ResourceRow
+      InsertNewRowInCache(Resource resource) {
+      dsHiveServer.ResourceRow row = cache.NewResourceRow();
+      cache.AddResourceRow(row);
+
+      return row;
+    }
+
+    protected override void FillCache() {
+      cache = adapter.GetDataByActive();
+    }
+
+    public override void SyncWithDb() {
+      adapter.Update(cache);
+    }
+
+    protected override bool PutInCache(Resource obj) {
+      return (obj is ClientInfo &&
+        (obj as ClientInfo).State != State.offline);
+    }
+
+    protected override IEnumerable<dsHiveServer.ResourceRow>
+      FindById(long id) {
+      return adapter.GetDataById(id);
+    }
+
+    protected override dsHiveServer.ResourceRow
+      FindCachedById(long id) {
+      return cache.FindByResourceId(id);
+    }
+
+    protected override IEnumerable<dsHiveServer.ResourceRow>
+      FindAll() {
+      return FindMultipleRows(
+        new Selector(adapter.GetData),
+        new Selector(cache.AsEnumerable<dsHiveServer.ResourceRow>));
+    }
+    #endregion
+
     #region IResourceAdapter Members
-    [MethodImpl(MethodImplOptions.Synchronized)]
-    public void UpdateResource(Resource resource) {
+    public bool GetById(Resource resource) {
       if (resource != null) {
         dsHiveServer.ResourceRow row =
-          data.FindByResourceId(resource.ResourceId);
+          GetRowById(resource.Id);
 
-        if (row == null) {
-          row = data.NewResourceRow();
-          data.AddResourceRow(row);
-
-          //write row to db to get primary key
-          adapter.Update(row);
-        } 
-
-        Convert(resource, row);
-        resource.ResourceId = row.ResourceId;
-      }
-    }
-
-    public bool GetResourceById(Resource resource) {
-      if (resource != null) {
-        dsHiveServer.ResourceRow row =
-          data.FindByResourceId(resource.ResourceId);
         if (row != null) {
           Convert(row, resource);
@@ -102,25 +144,17 @@
     }
 
-    public Resource GetResourceById(long resourceId) {
-      Resource resource = new Resource();
-      resource.ResourceId = resourceId;
-
-      if(GetResourceById(resource)) 
-        return resource;
-      else 
-        return null;
-    }
-
-    public Resource GetResourceByName(string name) {
-      dsHiveServer.ResourceRow row = null;
-
-      IEnumerable<dsHiveServer.ResourceRow> permOwners =
-        from r in
-          data.AsEnumerable<dsHiveServer.ResourceRow>()
-        where !r.IsNameNull() && r.Name == name
-        select r;
-
-      if (permOwners.Count<dsHiveServer.ResourceRow>() == 1)
-        row = permOwners.First<dsHiveServer.ResourceRow>();
+    public Resource GetByName(string name) {
+      dsHiveServer.ResourceRow row =
+        base.FindSingleRow(
+          delegate() {
+            return adapter.GetDataByName(name);
+          },
+          delegate() {
+            return from r in
+                     cache.AsEnumerable<dsHiveServer.ResourceRow>()
+                   where !r.IsNameNull() && 
+                          r.Name == name
+                   select r;
+          });
 
       if (row != null) {
@@ -134,34 +168,4 @@
     }
 
-    public ICollection<Resource> GetAllResources() {
-      IList<Resource> allResources =
-        new List<Resource>();
-      
-      foreach (dsHiveServer.ResourceRow row in data) {
-        Resource resource = new Resource();
-        Convert(row, resource);
-        allResources.Add(resource);
-      }
-
-      return allResources;
-    }
-
-    [MethodImpl(MethodImplOptions.Synchronized)]
-    public bool DeleteResource(Resource resource) {
-      if(resource != null) {
-        dsHiveServer.ResourceRow row =
-          data.FindByResourceId(resource.ResourceId);
-
-        if (row != null) {
-          row.Delete();
-          adapter.Update(row);
-
-          return true;
-        } 
-      }
-       
-      return false;
-    }
-
     #endregion
   }
Index: trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/UserAdapter.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/UserAdapter.cs	(revision 994)
+++ trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/UserAdapter.cs	(revision 995)
@@ -30,9 +30,12 @@
 
 namespace HeuristicLab.Hive.Server.ADODataAccess {
-  class UserAdapter : DataAdapterBase, IUserAdapter {
-    private dsHiveServerTableAdapters.HiveUserTableAdapter adapter =
-        new dsHiveServerTableAdapters.HiveUserTableAdapter();
-
-    private dsHiveServer.HiveUserDataTable data =
+  class UserAdapter :
+    DataAdapterBase<
+      dsHiveServerTableAdapters.HiveUserTableAdapter,
+      User,
+      dsHiveServer.HiveUserRow>,
+    IUserAdapter {
+    #region Fields
+    dsHiveServer.HiveUserDataTable data =
         new dsHiveServer.HiveUserDataTable();
 
@@ -52,7 +55,6 @@
     private IUserGroupAdapter UserGroupAdapter {
       get {
-        if(userGroupAdapter == null) {
+        if (userGroupAdapter == null)
           userGroupAdapter = ServiceLocator.GetUserGroupAdapter();
-        }
 
         return userGroupAdapter;
@@ -64,26 +66,19 @@
     private IJobAdapter JobAdapter {
       get {
-        if (jobAdapter == null) {
+        if (jobAdapter == null)
           jobAdapter = ServiceLocator.GetJobAdapter();
-        }
 
         return jobAdapter;
       }
     }
+    #endregion
 
-    public UserAdapter() {
-      adapter.Fill(data);
-    }
-
-    protected override void Update() {
-      this.adapter.Update(this.data);
-    }
-
-    private User Convert(dsHiveServer.HiveUserRow row, 
+    #region Overrides
+    protected override User Convert(dsHiveServer.HiveUserRow row,
       User user) {
       if (row != null && user != null) {
         /*Parent - PermissionOwner*/
-        user.PermissionOwnerId = row.PermissionOwnerId;
-        PermOwnerAdapter.GetPermissionOwnerById(user);
+        user.Id = row.PermissionOwnerId;
+        PermOwnerAdapter.GetById(user);
 
         /*User*/
@@ -98,63 +93,62 @@
     }
 
-    private dsHiveServer.HiveUserRow Convert(User user,
+    protected override dsHiveServer.HiveUserRow Convert(User user,
       dsHiveServer.HiveUserRow row) {
       if (user != null && row != null) {
-        row.Password = user.Password;
+        if (user.Password == null)
+          row.SetPasswordNull();
+        else
+          row.Password = user.Password;
 
         return row;
       } else
-        return null;     
+        return null;
     }
+
+    protected override dsHiveServer.HiveUserRow
+      InsertNewRow(User user) {
+      dsHiveServer.HiveUserRow row =
+        data.NewHiveUserRow();
+
+      row.PermissionOwnerId = user.Id;
+
+      data.AddHiveUserRow(row);
+
+      return row;
+    }
+
+    protected override void
+      UpdateRow(dsHiveServer.HiveUserRow row) {
+      adapter.Update(row);
+    }
+
+    protected override IEnumerable<dsHiveServer.HiveUserRow>
+      FindById(long id) {
+      return adapter.GetDataById(id);
+    }
+
+    protected override IEnumerable<dsHiveServer.HiveUserRow>
+      FindAll() {
+      return adapter.GetData();
+    }
+    #endregion
 
     #region IUserAdapter Members
 
     [MethodImpl(MethodImplOptions.Synchronized)]
-    public void UpdateUser(User user) {
+    public override void Update(User user) {
       if (user != null) {
-        PermOwnerAdapter.UpdatePermissionOwner(user);
+        PermOwnerAdapter.Update(user);
 
-        dsHiveServer.HiveUserRow row = 
-          data.FindByPermissionOwnerId(user.PermissionOwnerId);
-        if (row == null) {
-          row = data.NewHiveUserRow();
-          row.PermissionOwnerId = user.PermissionOwnerId;
-          data.AddHiveUserRow(row);
-        } 
-
-        Convert(user, row);
+        base.Update(user);
       }
     }
 
-    public User GetUserById(long userId) {
-      User user = new User();
-
-      dsHiveServer.HiveUserRow row =
-          data.FindByPermissionOwnerId(userId);
-
-      if(row != null) {
-        Convert(row, user);
-
-        return user;
-      } else {
-        return null;
-      }
-    }
-
-    public User GetUserByName(String name) {
-      User user = new User();
-
-      PermissionOwner permOwner =
-        PermOwnerAdapter.GetPermissionOwnerByName(name);
-
-      if (permOwner != null) {
-        dsHiveServer.HiveUserRow row =
-          data.FindByPermissionOwnerId(permOwner.PermissionOwnerId);
-
-        if (row != null) {
-          Convert(row, user);
-
-          return user;
-        }
+    public User GetByName(String name) {
+      if (name != null) {
+        return base.FindSingle(
+          delegate() {
+            return adapter.GetDataByName(name);
+          });
       }
 
@@ -162,44 +156,24 @@
     }
 
-    public ICollection<User> GetAllUsers() {
-      ICollection<User> allUsers =
-        new List<User>();
+    [MethodImpl(MethodImplOptions.Synchronized)]
+    public override bool Delete(User user) {
+      if (user != null) {
+        //Referential integrity with user groups
+        ICollection<UserGroup> userGroups =
+          UserGroupAdapter.MemberOf(user);
+        foreach (UserGroup group in userGroups) {
+          group.Members.Remove(user);
+          UserGroupAdapter.Update(group);
+        }
 
-      foreach (dsHiveServer.HiveUserRow row in data) {
-        User user = new User();
-        Convert(row, user);
-        allUsers.Add(user);
-      }
+        //Referential integrity with jobs
+        ICollection<Job> jobs =
+          JobAdapter.GetJobsOf(user);
+        foreach (Job job in jobs) {
+          JobAdapter.Delete(job);
+        }
 
-      return allUsers;
-    }
-
-    [MethodImpl(MethodImplOptions.Synchronized)]
-    public bool DeleteUser(User user) {
-      if (user != null) {
-        dsHiveServer.HiveUserRow row =
-          data.FindByPermissionOwnerId(user.PermissionOwnerId);
-
-        if (row != null) {
-          //Referential integrity with user groups
-          ICollection<UserGroup> userGroups =
-            UserGroupAdapter.MemberOf(user);
-          foreach (UserGroup group in userGroups) {
-            group.Members.Remove(user);
-            UserGroupAdapter.UpdateUserGroup(group);
-          }
-
-          //Referential integrity with jobs
-          ICollection<Job> jobs =
-            JobAdapter.GetJobsOf(user);
-          foreach (Job job in jobs) {
-            JobAdapter.DeleteJob(job);
-          }
-
-          row.Delete();
-          adapter.Update(row);
-
-          return PermOwnerAdapter.DeletePermissionOwner(user);
-        }
+        return base.Delete(user) &&
+            PermOwnerAdapter.Delete(user);
       }
 
Index: trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/UserGroupAdapter.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/UserGroupAdapter.cs	(revision 994)
+++ trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/UserGroupAdapter.cs	(revision 995)
@@ -31,16 +31,17 @@
 
 namespace HeuristicLab.Hive.Server.ADODataAccess {
-  class UserGroupAdapter: DataAdapterBase, IUserGroupAdapter {
-    private dsHiveServerTableAdapters.UserGroupTableAdapter adapter =
-        new dsHiveServerTableAdapters.UserGroupTableAdapter();
-
-    private dsHiveServer.UserGroupDataTable data =
-      new dsHiveServer.UserGroupDataTable();
+  class UserGroupAdapter: 
+    DataAdapterBase<
+      dsHiveServerTableAdapters.UserGroupTableAdapter, 
+      UserGroup, 
+      dsHiveServer.UserGroupRow>,
+    IUserGroupAdapter {
+
+    #region Fields
+    dsHiveServer.UserGroupDataTable data =
+        new dsHiveServer.UserGroupDataTable();
 
     private dsHiveServerTableAdapters.PermissionOwner_UserGroupTableAdapter permOwnerUserGroupAdapter =
       new dsHiveServerTableAdapters.PermissionOwner_UserGroupTableAdapter();
-
-    private dsHiveServer.PermissionOwner_UserGroupDataTable permOwnerUserGroupData =
-      new dsHiveServer.PermissionOwner_UserGroupDataTable();
 
     private IPermissionOwnerAdapter permOwnerAdapter = null;
@@ -65,28 +66,17 @@
       }
     }
-
-    public UserGroupAdapter() {
-      adapter.Fill(data);
-      permOwnerUserGroupAdapter.Fill(permOwnerUserGroupData);
-    }
-
-    protected override void Update() {
-      this.adapter.Update(this.data);
-      this.permOwnerUserGroupAdapter.Update(permOwnerUserGroupData);
-    }
-
-    private UserGroup Convert(dsHiveServer.UserGroupRow row,
+    #endregion
+
+    #region Overrides
+    protected override UserGroup Convert(dsHiveServer.UserGroupRow row,
       UserGroup userGroup) {
       if (row != null && userGroup != null) {
         /*Parent - Permission Owner*/
-        userGroup.PermissionOwnerId = row.PermissionOwnerId;
-        PermOwnerAdapter.GetPermissionOwnerById(userGroup);
+        userGroup.Id = row.PermissionOwnerId;
+        PermOwnerAdapter.GetById(userGroup);
 
         //first check for created references
-        IEnumerable<dsHiveServer.PermissionOwner_UserGroupRow> userGroupRows =
-          from permOwner in
-            permOwnerUserGroupData.AsEnumerable<dsHiveServer.PermissionOwner_UserGroupRow>()
-          where permOwner.UserGroupId == userGroup.PermissionOwnerId
-          select permOwner;
+        dsHiveServer.PermissionOwner_UserGroupDataTable userGroupRows =
+          permOwnerUserGroupAdapter.GetDataByUserGroupId(userGroup.Id);
 
         foreach (dsHiveServer.PermissionOwner_UserGroupRow permOwnerUserGroupRow in
@@ -97,5 +87,5 @@
             from p in
               userGroup.Members
-            where p.PermissionOwnerId == permOwnerUserGroupRow.PermissionOwnerId
+            where p.Id == permOwnerUserGroupRow.PermissionOwnerId
             select p;
           if (permOwners.Count<PermissionOwner>() == 1)
@@ -104,10 +94,10 @@
           if (permOwner == null) {
             PermissionOwner permissionOwner = 
-              UserAdapter.GetUserById(permOwnerUserGroupRow.PermissionOwnerId);
+              UserAdapter.GetById(permOwnerUserGroupRow.PermissionOwnerId);
 
             if (permissionOwner == null) {
               //is a user group
               permissionOwner =
-                GetUserGroupById(permOwnerUserGroupRow.PermissionOwnerId);
+                GetById(permOwnerUserGroupRow.PermissionOwnerId);
             }
 
@@ -122,10 +112,9 @@
 
         foreach (PermissionOwner permOwner in userGroup.Members) {
-          dsHiveServer.PermissionOwner_UserGroupRow permOwnerUserGroupRow =
-            permOwnerUserGroupData.FindByPermissionOwnerIdUserGroupId(
-              permOwner.PermissionOwnerId,
-              userGroup.PermissionOwnerId);
-
-          if (permOwnerUserGroupRow == null) {
+          dsHiveServer.PermissionOwner_UserGroupDataTable found =
+            permOwnerUserGroupAdapter.GetDataByPermownerUsergroupId(
+              permOwner.Id,
+              userGroup.Id);
+          if (found.Count != 1) {
             deleted.Add(permOwner);
           }
@@ -141,8 +130,8 @@
     }
 
-    private dsHiveServer.UserGroupRow Convert(UserGroup userGroup,
+    protected override dsHiveServer.UserGroupRow Convert(UserGroup userGroup,
       dsHiveServer.UserGroupRow row) {
       if (userGroup != null && row != null) {
-        row.PermissionOwnerId = userGroup.PermissionOwnerId;
+        row.PermissionOwnerId = userGroup.Id;
       
         //update references
@@ -150,35 +139,37 @@
           //first update the member to make sure it exists in the DB
           if (permOwner is User) {
-            UserAdapter.UpdateUser(permOwner as User);
+            UserAdapter.Update(permOwner as User);
           } else if (permOwner is UserGroup) {
-            UpdateUserGroup(permOwner as UserGroup);
+            Update(permOwner as UserGroup);
           }
 
           //secondly check for created references
           dsHiveServer.PermissionOwner_UserGroupRow permOwnerUserGroupRow =
-            permOwnerUserGroupData.FindByPermissionOwnerIdUserGroupId(
-              permOwner.PermissionOwnerId,
-              userGroup.PermissionOwnerId);
+            null;
+          dsHiveServer.PermissionOwner_UserGroupDataTable found = 
+            permOwnerUserGroupAdapter.GetDataByPermownerUsergroupId(
+              permOwner.Id,
+              userGroup.Id);
+          if (found.Count == 1)
+            permOwnerUserGroupRow = found[0];
 
           if (permOwnerUserGroupRow == null) {
             permOwnerUserGroupRow = 
-              permOwnerUserGroupData.NewPermissionOwner_UserGroupRow();
+              found.NewPermissionOwner_UserGroupRow();
 
             permOwnerUserGroupRow.PermissionOwnerId =
-              permOwner.PermissionOwnerId;
+              permOwner.Id;
             permOwnerUserGroupRow.UserGroupId =
-              userGroup.PermissionOwnerId;
-
-            permOwnerUserGroupData.AddPermissionOwner_UserGroupRow(
-              permOwnerUserGroupRow);
+              userGroup.Id;
+
+            found.AddPermissionOwner_UserGroupRow(permOwnerUserGroupRow);
+
+            permOwnerUserGroupAdapter.Update(permOwnerUserGroupRow);
           }
         }
 
         //thirdly check for deleted references
-        IEnumerable<dsHiveServer.PermissionOwner_UserGroupRow> userGroupRows = 
-          from permOwner in 
-            permOwnerUserGroupData.AsEnumerable<dsHiveServer.PermissionOwner_UserGroupRow>()
-          where permOwner.UserGroupId == userGroup.PermissionOwnerId  
-          select permOwner;
+        dsHiveServer.PermissionOwner_UserGroupDataTable userGroupRows =
+            permOwnerUserGroupAdapter.GetDataByUserGroupId(userGroup.Id);
 
         ICollection<dsHiveServer.PermissionOwner_UserGroupRow> deleted =
@@ -192,5 +183,5 @@
             from p in
               userGroup.Members
-            where p.PermissionOwnerId == permOwnerUserGroupRow.PermissionOwnerId
+            where p.Id == permOwnerUserGroupRow.PermissionOwnerId
             select p;
 
@@ -203,81 +194,62 @@
         }
 
-        foreach (dsHiveServer.PermissionOwner_UserGroupRow permOwnerUserGroupRow in
-          deleted) {
-          permOwnerUserGroupData.RemovePermissionOwner_UserGroupRow(
-            permOwnerUserGroupRow);
-        }
-
+        foreach (dsHiveServer.PermissionOwner_UserGroupRow 
+          permOwnerUserGroupRow in deleted) {
+          permOwnerUserGroupRow.Delete();
+          permOwnerUserGroupAdapter.Update(permOwnerUserGroupRow);
+        }
       }
 
       return row;
     }
+
+    protected override dsHiveServer.UserGroupRow
+      InsertNewRow(UserGroup group) {
+      dsHiveServer.UserGroupRow row =
+        data.NewUserGroupRow();
+
+      row.PermissionOwnerId = group.Id;
+
+      data.AddUserGroupRow(row);
+      adapter.Update(row);
+
+      return row;
+    }
+
+    protected override void
+     UpdateRow(dsHiveServer.UserGroupRow row) {
+      adapter.Update(row);
+    }
+
+    protected override IEnumerable<dsHiveServer.UserGroupRow>
+      FindById(long id) {
+      return adapter.GetDataById(id);
+    }
+
+    protected override IEnumerable<dsHiveServer.UserGroupRow>
+      FindAll() {
+      return adapter.GetData();
+    }
+    #endregion
 
     #region IUserGroupAdapter Members
     [MethodImpl(MethodImplOptions.Synchronized)]
-    public void UpdateUserGroup(UserGroup group) {
+    public override void Update(UserGroup group) {
       if (group != null) {
-        PermOwnerAdapter.UpdatePermissionOwner(group);
-
-        dsHiveServer.UserGroupRow row =
-          data.FindByPermissionOwnerId(group.PermissionOwnerId);
-
-        if (row == null) {
-          row = data.NewUserGroupRow();
-          row.PermissionOwnerId = group.PermissionOwnerId;
-          data.AddUserGroupRow(row);
-        }
-
-        Convert(group, row);
-      }
-    }
-
-    public UserGroup GetUserGroupById(long userGroupId) {
-      UserGroup userGroup = new UserGroup();
-
-      dsHiveServer.UserGroupRow row =
-        data.FindByPermissionOwnerId(userGroupId);
-
-      if (row != null) {
-        Convert(row, userGroup);
-
-        return userGroup;
-      } else {
-        return null;
-      }
-    }
-
-    public UserGroup GetUserGroupByName(string name) {
-      UserGroup group = new UserGroup();
-
-      PermissionOwner permOwner =
-        PermOwnerAdapter.GetPermissionOwnerByName(name);
-
-      if (permOwner != null) {
-        dsHiveServer.UserGroupRow row =
-          data.FindByPermissionOwnerId(permOwner.PermissionOwnerId);
-
-        if (row != null) {
-          Convert(row, group);
-
-          return group;
-        }
+        PermOwnerAdapter.Update(group);
+
+        base.Update(group);
+      }
+    }
+
+    public UserGroup GetByName(String name) {
+      if (name != null) {
+        return base.FindSingle(
+          delegate() {
+            return adapter.GetDataByName(name);
+          });
       }
 
       return null;
-    }
-
-    public ICollection<UserGroup> GetAllUserGroups() {
-      ICollection<UserGroup> allUserGroups =
-        new List<UserGroup>();
-
-      foreach (dsHiveServer.UserGroupRow row in data) {
-        UserGroup userGroup = new UserGroup();
-
-        Convert(row, userGroup);
-        allUserGroups.Add(userGroup);
-      }
-
-      return allUserGroups;
     }
 
@@ -287,14 +259,11 @@
       
       if (permOwner != null) {
-        IEnumerable<dsHiveServer.PermissionOwner_UserGroupRow> userGroupRows =
-         from userGroup in
-           permOwnerUserGroupData.AsEnumerable<dsHiveServer.PermissionOwner_UserGroupRow>()
-         where userGroup.PermissionOwnerId == permOwner.PermissionOwnerId
-         select userGroup;
+        dsHiveServer.PermissionOwner_UserGroupDataTable userGroupRows =
+          permOwnerUserGroupAdapter.GetDataByPermissionOwnerId(permOwner.Id);
 
         foreach (dsHiveServer.PermissionOwner_UserGroupRow userGroupRow in
           userGroupRows) {
           UserGroup userGroup = 
-            GetUserGroupById(userGroupRow.UserGroupId);
+            GetById(userGroupRow.UserGroupId);
           userGroups.Add(userGroup);
         }
@@ -305,31 +274,8 @@
 
     [MethodImpl(MethodImplOptions.Synchronized)]
-    public bool DeleteUserGroup(UserGroup group) {
+    public override bool Delete(UserGroup group) {
       if (group != null) {
-        dsHiveServer.UserGroupRow row =
-          data.FindByPermissionOwnerId(group.PermissionOwnerId);
-
-        if (row != null) {
-          ICollection<dsHiveServer.PermissionOwner_UserGroupRow> deleted =
-            new List<dsHiveServer.PermissionOwner_UserGroupRow>();
-          
-          foreach (dsHiveServer.PermissionOwner_UserGroupRow permOwnerUserGroupRow in
-            permOwnerUserGroupData) {
-            if (permOwnerUserGroupRow.UserGroupId == group.PermissionOwnerId || 
-              permOwnerUserGroupRow.PermissionOwnerId == group.PermissionOwnerId) {
-              deleted.Add(permOwnerUserGroupRow);
-            }
-          }
-
-          foreach (dsHiveServer.PermissionOwner_UserGroupRow permOwnerUserGroupRow in
-            deleted) {
-            permOwnerUserGroupData.RemovePermissionOwner_UserGroupRow(
-              permOwnerUserGroupRow);
-          }
-
-          row.Delete();
-          adapter.Update(row);
-          return PermOwnerAdapter.DeletePermissionOwner(group);
-        }
+        return base.Delete(group) && 
+          PermOwnerAdapter.Delete(group);
       }
 
